﻿Imports MindFusion.Charting.Wpf
Imports System.Windows.Media.Effects

Class Window1
    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.       
        barChart1.X2Axes.Add(New MindFusion.Charting.Wpf.Axis)
        barChart1.Y2Axes.Add(New MindFusion.Charting.Wpf.Axis)

        Dim series As BarSeries = New BarSeries
        barChart1.Series.Add(series)
        series.TopLabelType = LabelType.ChartData

        series.Fills = New BrushCollection
        Dim ef As DropShadowEffect = New DropShadowEffect
        ef.Opacity = 0.7
        ef.ShadowDepth = 3
        series.Effect = ef
        series.Fills.Add(New SolidColorBrush(Color.FromRgb(153, 0, 102)))
        series.Fills.Add(New SolidColorBrush(Color.FromRgb(255, 20, 177)))
        series.Fills.Add(New SolidColorBrush(Color.FromRgb(20, 255, 99)))
        series.Fills.Add(New SolidColorBrush(Color.FromRgb(102, 153, 0)))
        series.Fills.Add(New SolidColorBrush(Color.FromRgb(0, 102, 153)))

        applyVertSettings()

    End Sub

    Private Sub applyVertSettings()

        'If barChart1.Series.Count = 0 Then
        '    Return
        'End If

        resetX2AxisSettings()

        barChart1.YAxes(0).Title = "Kilometers"
        barChart1.YAxes(0).TitleOffset = 10.0
        barChart1.YAxes(0).Interval = 20
        barChart1.YAxes(0).LabelType = LabelType.AutoScale

        barChart1.XAxes(0).Title = ""
        barChart1.XAxes(0).Interval = 1
        barChart1.XAxes(0).LabelType = LabelType.CustomText

        barChart1.Y2Axes(0).MinValue = 0
        barChart1.Y2Axes(0).MaxValue = 50
        barChart1.Y2Axes(0).Interval = 12.5
        barChart1.Y2Axes(0).LabelType = LabelType.AutoScale
        barChart1.Y2Axes(0).Title = "Miles"
        barChart1.Y2Axes(0).TitleOffset = 10.0

        Dim series As BarSeries = TryCast(barChart1.Series(0), BarSeries)
        barChart1.BarType = BarType.Vertical
        series.YData = New DoubleCollection(New Double() {25, 38, 45, 62, 51})
        series.XData = New DoubleCollection(New Double() {1, 2, 3, 4, 5})

        barChart1.XAxes(0).Labels = New String() {"Shoes", "Food", "Clothes", "Furniture", "Appliances"}

    End Sub

    Private Sub applyHorizontalSettings()
        'If barChart1.Series.Count = 0 Then
        '    Return
        'End If

        resetY2AxisSettings()

        barChart1.XAxes(0).Title = "Kilometers"
        barChart1.XAxes(0).TitleOffset = 10.0
        barChart1.XAxes(0).LabelType = LabelType.AutoScale
        barChart1.XAxes(0).Interval = 20

        barChart1.YAxes(0).Title = ""
        barChart1.YAxes(0).LabelType = LabelType.CustomText
        barChart1.YAxes(0).Interval = 1


        barChart1.X2Axes(0).MinValue = 0
        barChart1.X2Axes(0).MaxValue = 50
        barChart1.X2Axes(0).Interval = 12.5
        barChart1.X2Axes(0).LabelType = LabelType.AutoScale
        barChart1.X2Axes(0).Title = "Miles"
        barChart1.X2Axes(0).TitleOffset = 10.0

        Dim series As BarSeries = TryCast(barChart1.Series(0), BarSeries)
        barChart1.BarType = BarType.Horizontal
        series.XData = New DoubleCollection(New Double() {25, 38, 45, 62, 51})
        series.YData = New DoubleCollection(New Double() {1, 2, 3, 4, 5})

        barChart1.YAxes(0).Labels = New String() {"Shoes", "Food", "Clothes", "Furniture", "Appliances"}
    End Sub

    Private Sub resetX2AxisSettings()
        barChart1.X2Axes(0).MinValue = Double.NaN
        barChart1.X2Axes(0).MaxValue = Double.NaN
        barChart1.X2Axes(0).Interval = Double.NaN
        barChart1.X2Axes(0).Title = ""
        barChart1.X2Axes(0).LabelType = LabelType.Empty
    End Sub

    Private Sub resetY2AxisSettings()
        barChart1.Y2Axes(0).MinValue = Double.NaN
        barChart1.Y2Axes(0).MaxValue = Double.NaN
        barChart1.Y2Axes(0).Interval = Double.NaN
        barChart1.Y2Axes(0).Title = ""
        barChart1.Y2Axes(0).LabelType = LabelType.Empty
    End Sub

    Private Sub cbHorizontal_CheckChanged(ByVal sender As Object, ByVal e As RoutedEventArgs)
        If cbHorizontal.IsChecked.Value = True Then
            applyHorizontalSettings()
        Else
            applyVertSettings()
        End If

    End Sub

End Class
